not-yet-commons-ssl-0.3.17 released! (March 16th, 2015)

Requires Java 1.5.x or higher.

Please see our ssl page for code examples on how to use this library.


Design Goals: about.html
Code Examples: SSL/TLS  |  PKCS #8  |  PBE
Join Mailing List:
Mailing List Archives:
Checkout From Subversion: svn co not-yet-commons-ssl
Browse Subversion (via viewvc):
License (Apache 2.0 +'s MIT license): LICENSE.txt


We're calling this library "Not-Yet-Commons-SSL" since we have the intention of one day becoming an official Apache project. Not-Yet-Commons-SSL was originally developed by Credit Union Central of British Columbia. The webpages, releases, and code here on have no relationship to the Apache Software Foundation, but all code is licensed under ASL 2.0.

The ASN.1 parsing code comes directly from BouncyCastle ( The PKCS12 key derivation function (for some PKCS8 version 1.5 encrypted keys) also comes from BouncyCastle. Presumably they got it from RSA's PKCS12 specification ( BouncyCastle maintains copyright over all the code used, but allows us to reuse and redistribute (the BouncyCastle license is compatible with ASL 2.0). We are very thankful for their excellent code.

Not-Yet-Commons-SSL would never have happened without Oleg Kalnichevski's excellent "contrib" example in the HttpComponents SVN repository. His and examples were the seeds for all of this. Evil Comrade Oleg's Javadocs on those classes were also extremely helpful. We only one day hope that we can write Javadocs like that (hopefully by 0.7.0!).